Index: /pjproject/trunk/pjmedia/src/pjmedia/transport_srtp.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/transport_srtp.c	(revision 5596)
+++ /pjproject/trunk/pjmedia/src/pjmedia/transport_srtp.c	(revision 5597)
@@ -1380,275 +1363,49 @@
     pj_bzero(&srtp->tx_policy_neg, sizeof(srtp->tx_policy_neg));
 
-    srtp->offerer_side = sdp_remote == NULL;
-
-    m_rem = sdp_remote ? sdp_remote->media[media_index] : NULL;
-    m_loc = sdp_local->media[media_index];
-
-    /* Bypass if media transport is not RTP/AVP or RTP/SAVP */
-    if (pj_stricmp(&m_loc->desc.transport, &ID_RTP_AVP)  != 0 &&
-	pj_stricmp(&m_loc->desc.transport, &ID_RTP_SAVP) != 0)
-	goto BYPASS_SRTP;
-
-    /* If the media is inactive, do nothing. */
-    /* No, we still need to process SRTP offer/answer even if the media is
-     * marked as inactive, because the transport is still alive in this
-     * case (e.g. for keep-alive). See:
-     *   http://trac.pjsip.org/repos/ticket/1079
-     */
-    /*
-    if (pjmedia_sdp_media_find_attr(m_loc, &ID_INACTIVE, NULL) ||
-	(m_rem && pjmedia_sdp_media_find_attr(m_rem, &ID_INACTIVE, NULL)))
-	goto BYPASS_SRTP;
-    */
-
-    /* Check remote media transport & set local media transport
-     * based on SRTP usage option.
-     */
-    if (srtp->offerer_side) {
-
-	/* Generate transport */
-	switch (srtp->setting.use) {
-	    case PJMEDIA_SRTP_DISABLED:
-		goto BYPASS_SRTP;
-	    case PJMEDIA_SRTP_OPTIONAL:
-		m_loc->desc.transport =
-				(srtp->peer_use == PJMEDIA_SRTP_MANDATORY)?
-				ID_RTP_SAVP : ID_RTP_AVP;
-		break;
-	    case PJMEDIA_SRTP_MANDATORY:
-		m_loc->desc.transport = ID_RTP_SAVP;
-		break;
+    srtp->offerer_side = (sdp_remote == NULL);
+
+    status = pjmedia_transport_encode_sdp(srtp->member_tp, sdp_pool,
+					  sdp_local, sdp_remote, media_index);
+    if (status != PJ_SUCCESS || srtp->bypass_srtp)
+	return status;
+
+    /* Invoke encode_sdp() of all keying methods */
+    for (i=0; i < srtp->keying_cnt; ) {
+	pj_status_t st;
+	st = pjmedia_transport_encode_sdp(srtp->keying[i], sdp_pool,
+					  sdp_local, sdp_remote,
+					  media_index);
+	if (st != PJ_SUCCESS) {
+	    /* This keying method returns error, remove it */
+	    pj_array_erase(srtp->keying, sizeof(srtp->keying[0]),
+			   srtp->keying_cnt, i);
+	    srtp->keying_cnt--;
+	    last_err_st = st;
+	    continue;
 	}
 
-	/* Generate crypto attribute if not yet */
-	if (pjmedia_sdp_media_find_attr(m_loc, &ID_CRYPTO, NULL) == NULL) {
-	    int tag = 1;
-
-	    /* Offer only current active crypto if any, otherwise offer all
-	     * crypto-suites in the setting.
-	     */
-	    for (i=0; i<srtp->setting.crypto_count; ++i) {
-		if (srtp->tx_policy.name.slen &&
-		    pj_stricmp(&srtp->tx_policy.name,
-			       &srtp->setting.crypto[i].name) != 0)
-		{
-		    continue;
-		}
-
-		buffer_len = MAXLEN;
-		status = generate_crypto_attr_value(srtp->pool, buffer, &buffer_len,
-						    &srtp->setting.crypto[i],
-						    tag);
-		if (status != PJ_SUCCESS)
-		    return status;
-
-		/* If buffer_len==0, just skip the crypto attribute. */
-		if (buffer_len) {
-		    pj_strset(&attr_value, buffer, buffer_len);
-		    attr = pjmedia_sdp_attr_create(srtp->pool, ID_CRYPTO.ptr,
-						   &attr_value);
-		    m_loc->attr[m_loc->attr_count++] = attr;
-		    ++tag;
-		}
+	if (!srtp_crypto_empty(&srtp->tx_policy_neg) &&
+	    !srtp_crypto_empty(&srtp->rx_policy_neg))
+	{
+	    /* SRTP nego is done, let's destroy any other keying. */
+	    unsigned j;
+	    for (j = 0; j < srtp->keying_cnt; ++j) {
+		if (j != i)
+		    pjmedia_transport_close(srtp->keying[j]);
 	    }
+	    srtp->keying_cnt = 1;
+	    srtp->keying[0] = srtp->keying[i];
+	    srtp->keying_pending_cnt = 0;
+	    break;
 	}
 
-    } else {
-	/* Answerer side */
-
-	pj_assert(sdp_remote && m_rem);
-
-	/* Generate transport */
-	switch (srtp->setting.use) {
-	    case PJMEDIA_SRTP_DISABLED:
-		if (pj_stricmp(&m_rem->desc.transport, &ID_RTP_SAVP) == 0)
-		    return PJMEDIA_SRTP_ESDPINTRANSPORT;
-		goto BYPASS_SRTP;
-	    case PJMEDIA_SRTP_OPTIONAL:
-		m_loc->desc.transport = m_rem->desc.transport;
-		break;
-	    case PJMEDIA_SRTP_MANDATORY:
-		if (pj_stricmp(&m_rem->desc.transport, &ID_RTP_SAVP) != 0)
-		    return PJMEDIA_SRTP_ESDPINTRANSPORT;
-		m_loc->desc.transport = ID_RTP_SAVP;
-		break;
-	}
-
-	/* Generate crypto attribute if not yet */
-	if (pjmedia_sdp_media_find_attr(m_loc, &ID_CRYPTO, NULL) == NULL) {
-
-	    pjmedia_srtp_crypto tmp_rx_crypto;
-	    pj_bool_t has_crypto_attr = PJ_FALSE;
-	    int matched_idx = -1;
-	    int chosen_tag = 0;
-	    int tags[64]; /* assume no more than 64 crypto attrs in a media */
-	    unsigned cr_attr_count = 0;
-
-	    /* Find supported crypto-suite, get the tag, and assign policy_local */
-	    for (i=0; i<m_rem->attr_count; ++i) {
-		if (pj_stricmp(&m_rem->attr[i]->name, &ID_CRYPTO) != 0)
-		    continue;
-
-		has_crypto_attr = PJ_TRUE;
-
-		status = parse_attr_crypto(srtp->pool, m_rem->attr[i],
-					   &tmp_rx_crypto, &tags[cr_attr_count]);
-		if (status != PJ_SUCCESS)
-		    return status;
-
-		/* Check duplicated tag */
-		for (j=0; j<cr_attr_count; ++j) {
-		    if (tags[j] == tags[cr_attr_count]) {
-			DEACTIVATE_MEDIA(sdp_pool, m_loc);
-			return PJMEDIA_SRTP_ESDPDUPCRYPTOTAG;
-		    }
-		}
-
-		if (matched_idx == -1) {
-		    /* lets see if the crypto-suite offered is supported */
-		    for (j=0; j<srtp->setting.crypto_count; ++j)
-			if (pj_stricmp(&tmp_rx_crypto.name,
-				       &srtp->setting.crypto[j].name) == 0)
-			{
-			    int cs_idx = get_crypto_idx(&tmp_rx_crypto.name);
-			    
-	    		    if (cs_idx == -1)
-	    		        return PJMEDIA_SRTP_ENOTSUPCRYPTO;
-
-			    /* Force to use test key */
-			    /* bad keys for snom: */
-			    //char *hex_test_key = "58b29c5c8f42308120ce857e439f2d"
-			    //		     "7810a8b10ad0b1446be5470faea496";
-			    //char *hex_test_key = "20a26aac7ba062d356ff52b61e3993"
-			    //		     "ccb78078f12c64db94b9c294927fd0";
-			    //pj_str_t *test_key = &srtp->setting.crypto[j].key;
-			    //char  *raw_test_key = pj_pool_zalloc(srtp->pool, 64);
-			    //hex_string_to_octet_string(
-			    //		raw_test_key,
-			    //		hex_test_key,
-			    //		strlen(hex_test_key));
-			    //pj_strset(test_key, raw_test_key,
-			    //	  crypto_suites[cs_idx].cipher_key_len);
-			    /* EO Force to use test key */
-
-			    if (tmp_rx_crypto.key.slen !=
-				(int)crypto_suites[cs_idx].cipher_key_len)
-				return PJMEDIA_SRTP_EINKEYLEN;
-
-			    srtp->rx_policy_neg = tmp_rx_crypto;
-			    chosen_tag = tags[cr_attr_count];
-			    matched_idx = j;
-    			    break;
-			}
-		}
-		cr_attr_count++;
-	    }
-
-	    /* Check crypto negotiation result */
-	    switch (srtp->setting.use) {
-		case PJMEDIA_SRTP_DISABLED:
-		    pj_assert(!"Should never reach here");
-		    break;
-
-		case PJMEDIA_SRTP_OPTIONAL:
-		    /* bypass SRTP when no crypto-attr and remote uses RTP/AVP */
-		    if (!has_crypto_attr &&
-			pj_stricmp(&m_rem->desc.transport, &ID_RTP_AVP) == 0)
-			goto BYPASS_SRTP;
-		    /* bypass SRTP when nothing match and remote uses RTP/AVP */
-		    else if (matched_idx == -1 &&
-			pj_stricmp(&m_rem->desc.transport, &ID_RTP_AVP) == 0)
-			goto BYPASS_SRTP;
-		    break;
-
-		case PJMEDIA_SRTP_MANDATORY:
-		    /* Do nothing, intentional */
-		    break;
-	    }
-
-	    /* No crypto attr */
-	    if (!has_crypto_attr) {
-		DEACTIVATE_MEDIA(sdp_pool, m_loc);
-		return PJMEDIA_SRTP_ESDPREQCRYPTO;
-	    }
-
-	    /* No crypto match */
-	    if (matched_idx == -1) {
-		DEACTIVATE_MEDIA(sdp_pool, m_loc);
-		return PJMEDIA_SRTP_ENOTSUPCRYPTO;
-	    }
-
-	    /* we have to generate crypto answer,
-	     * with srtp->tx_policy_neg matched the offer
-	     * and rem_tag contains matched offer tag.
-	     */
-	    buffer_len = MAXLEN;
-	    status = generate_crypto_attr_value(srtp->pool, buffer, &buffer_len,
-						&srtp->setting.crypto[matched_idx],
-						chosen_tag);
-	    if (status != PJ_SUCCESS)
-		return status;
-
-	    srtp->tx_policy_neg = srtp->setting.crypto[matched_idx];
-
-	    /* If buffer_len==0, just skip the crypto attribute. */
-	    if (buffer_len) {
-		pj_strset(&attr_value, buffer, buffer_len);
-		attr = pjmedia_sdp_attr_create(sdp_pool, ID_CRYPTO.ptr,
-					       &attr_value);
-		m_loc->attr[m_loc->attr_count++] = attr;
-	    }
-
-	    /* At this point, we get valid rx_policy_neg & tx_policy_neg. */
-	}
-
-    }
-    goto PROPAGATE_MEDIA_CREATE;
-
-BYPASS_SRTP:
-    /* Do not update this flag here as actually the media session hasn't been
-     * updated.
-     */
-    //srtp->bypass_srtp = PJ_TRUE;
-
-PROPAGATE_MEDIA_CREATE:
-    return pjmedia_transport_encode_sdp(srtp->member_tp, sdp_pool,
-					sdp_local, sdp_remote, media_index);
-}
-
-
-static pj_status_t fill_local_crypto(pj_pool_t *pool,
-			             const pjmedia_sdp_media *m_loc, 
-			             pjmedia_srtp_crypto loc_crypto[],
-			             int *count)
-{
-    int i;
-    int crypto_count = 0;
-    pj_status_t status = PJ_SUCCESS;
-    
-    for (i = 0; i < *count; ++i) {
-	pj_bzero(&loc_crypto[i], sizeof(loc_crypto[i]));
-    }
-
-    for (i = 0; i < (int)m_loc->attr_count; ++i) {	
-	pjmedia_srtp_crypto tmp_crypto;
-	int loc_tag;
-
-	if (pj_stricmp(&m_loc->attr[i]->name, &ID_CRYPTO) != 0)
-	    continue;
-
-	status = parse_attr_crypto(pool, m_loc->attr[i],
-				   &tmp_crypto, &loc_tag);
-	if (status != PJ_SUCCESS)
-	    return status;
-
-	if (loc_tag > *count)
-	    return PJMEDIA_SRTP_ESDPINCRYPTOTAG;
-
-	loc_crypto[loc_tag-1] = tmp_crypto;
-	++crypto_count;
-    }
-    *count = crypto_count;
-    return status;
+	i++;
+    }
+
+    /* All keying method failed to process remote SDP? */
+    if (srtp->keying_cnt == 0)
+	return last_err_st;
+
+    return PJ_SUCCESS;
 }
 
@@ -1661,168 +1418,64 @@
 {
     struct transport_srtp *srtp = (struct transport_srtp*) tp;
-    pjmedia_sdp_media *m_rem, *m_loc;
+    pj_status_t last_err_st = PJ_EBUG;
     pj_status_t status;
     unsigned i;
-    pjmedia_srtp_crypto	loc_crypto[PJMEDIA_SRTP_MAX_CRYPTOS];
-    int loc_cryto_cnt = PJMEDIA_SRTP_MAX_CRYPTOS;
 
     PJ_ASSERT_RETURN(tp && pool && sdp_local && sdp_remote, PJ_EINVAL);
 
-    m_rem = sdp_remote->media[media_index];
-    m_loc = sdp_local->media[media_index];
-
-    if (pj_stricmp(&m_rem->desc.transport, &ID_RTP_SAVP) == 0)
-	srtp->peer_use = PJMEDIA_SRTP_MANDATORY;
-    else
-	srtp->peer_use = PJMEDIA_SRTP_OPTIONAL;
-
-    /* For answerer side, this function will just have to start SRTP */
-
-    /* Check remote media transport & set local media transport
-     * based on SRTP usage option.
+    status = pjmedia_transport_media_start(srtp->member_tp, pool,
+					   sdp_local, sdp_remote,
+				           media_index);
+    if (status != PJ_SUCCESS || srtp->bypass_srtp)
+	return status;
+
+    /* Invoke media_start() of all keying methods */
+    for (i=0; i < srtp->keying_cnt; ) {
+	status = pjmedia_transport_media_start(srtp->keying[i], pool,
+					       sdp_local, sdp_remote,
+					       media_index);
+	if (status != PJ_SUCCESS) {
+	    /* This keying method returns error, remove it */
+	    pj_array_erase(srtp->keying, sizeof(srtp->keying[0]),
+			   srtp->keying_cnt, i);
+	    srtp->keying_cnt--;
+	    last_err_st = status;
+	    continue;
+	}
+
+	if (!srtp_crypto_empty(&srtp->tx_policy_neg) &&
+	    !srtp_crypto_empty(&srtp->rx_policy_neg))
+	{
+	    /* SRTP nego is done, let's destroy any other keying. */
+	    unsigned j;
+	    for (j = 0; j < srtp->keying_cnt; ++j) {
+		if (j != i)
+		    pjmedia_transport_close(srtp->keying[j]);
+	    }
+	    srtp->keying_cnt = 1;
+	    srtp->keying[0] = srtp->keying[i];
+	    srtp->keying_pending_cnt = 0;
+	    break;
+	}
+
+	i++;
+    }
+
+    /* All keying method failed to process remote SDP? */
+    if (srtp->keying_cnt == 0)
+	return last_err_st;
+
+    /* If SRTP key is being negotiated, just return now.
+     * The keying method should start the SRTP once keying nego is done.
      */
-    if (srtp->offerer_side) {
-	if (srtp->setting.use == PJMEDIA_SRTP_DISABLED) {
-	    if (pjmedia_sdp_media_find_attr(m_rem, &ID_CRYPTO, NULL)) {
-		DEACTIVATE_MEDIA(pool, m_loc);
-		return PJMEDIA_SRTP_ESDPINCRYPTO;
-	    }
-	    goto BYPASS_SRTP;
-	} else if (srtp->setting.use == PJMEDIA_SRTP_OPTIONAL) {
-	    // Regardless the answer's transport type (RTP/AVP or RTP/SAVP),
-	    // the answer must be processed through in optional mode.
-	    // Please note that at this point transport type is ensured to be
-	    // RTP/AVP or RTP/SAVP, see transport_media_create()
-	    //if (pj_stricmp(&m_rem->desc.transport, &m_loc->desc.transport)) {
-		//DEACTIVATE_MEDIA(pool, m_loc);
-		//return PJMEDIA_SDP_EINPROTO;
-	    //}
-	    fill_local_crypto(srtp->pool, m_loc, loc_crypto, &loc_cryto_cnt);
-	} else if (srtp->setting.use == PJMEDIA_SRTP_MANDATORY) {
-	    if (pj_stricmp(&m_rem->desc.transport, &ID_RTP_SAVP)) {
-		DEACTIVATE_MEDIA(pool, m_loc);
-		return PJMEDIA_SDP_EINPROTO;
-	    }
-	    fill_local_crypto(srtp->pool, m_loc, loc_crypto, &loc_cryto_cnt);
-	}
-    }
-
-    if (srtp->offerer_side) {
-	/* find supported crypto-suite, get the tag, and assign policy_local */
-	pjmedia_srtp_crypto tmp_tx_crypto;
-	pj_bool_t has_crypto_attr = PJ_FALSE;
-	int rem_tag;
-	int j;
-
-	for (i=0; i<m_rem->attr_count; ++i) {
-	    if (pj_stricmp(&m_rem->attr[i]->name, &ID_CRYPTO) != 0)
-		continue;
-
-	    /* more than one crypto attribute in media answer */
-	    if (has_crypto_attr) {
-		DEACTIVATE_MEDIA(pool, m_loc);
-		return PJMEDIA_SRTP_ESDPAMBIGUEANS;
-	    }
-
-	    has_crypto_attr = PJ_TRUE;
-
-	    status = parse_attr_crypto(srtp->pool, m_rem->attr[i],
-				       &tmp_tx_crypto, &rem_tag);
-	    if (status != PJ_SUCCESS)
-		return status;
-
-
-	    /* Tag range check, our tags in the offer must be in the SRTP 
-	     * setting range, so does the remote answer's. The remote answer's 
-	     * tag must not exceed the tag range of the local offer.
-	     */
-	    if (rem_tag < 1 || rem_tag > (int)srtp->setting.crypto_count ||
-		rem_tag > loc_cryto_cnt) 
-	    
-	    {
-		DEACTIVATE_MEDIA(pool, m_loc);
-		return PJMEDIA_SRTP_ESDPINCRYPTOTAG;
-	    }
-
-	    /* match the crypto name */
-	    if (pj_stricmp(&tmp_tx_crypto.name, 
-			   &loc_crypto[rem_tag-1].name) != 0)		
-	    {
-		DEACTIVATE_MEDIA(pool, m_loc);
-		return PJMEDIA_SRTP_ECRYPTONOTMATCH;
-	    }
-
-	    /* Find the crypto from the setting. */
-	    for (j = 0; j < (int)srtp->setting.crypto_count; ++j) {
-		if (pj_stricmp(&tmp_tx_crypto.name, 
-			       &srtp->setting.crypto[j].name) == 0) 
-		
-		{
-		    srtp->tx_policy_neg = srtp->setting.crypto[j];
-		    break;
-		}		
-	    }
-	    
-	    srtp->rx_policy_neg = tmp_tx_crypto;
-	}
-
-	if (srtp->setting.use == PJMEDIA_SRTP_DISABLED) {
-	    /* should never reach here */
-	    goto BYPASS_SRTP;
-	} else if (srtp->setting.use == PJMEDIA_SRTP_OPTIONAL) {
-	    if (!has_crypto_attr)
-		goto BYPASS_SRTP;
-	} else if (srtp->setting.use == PJMEDIA_SRTP_MANDATORY) {
-	    if (!has_crypto_attr) {
-		DEACTIVATE_MEDIA(pool, m_loc);
-		return PJMEDIA_SRTP_ESDPREQCRYPTO;
-	    }
-	}
-
-	/* At this point, we get valid rx_policy_neg & tx_policy_neg. */
-    }
-
-    /* Make sure we have the SRTP policies */
-    if (srtp_crypto_empty(&srtp->tx_policy_neg) ||
-	srtp_crypto_empty(&srtp->rx_policy_neg))
-    {
-	goto BYPASS_SRTP;
-    }
-
-    /* Reset probation counts */
-    srtp->probation_cnt = PROBATION_CNT_INIT;
-
-    /* Got policy_local & policy_remote, let's initalize the SRTP */
-
-    /* Ticket #1075: media_start() is called whenever media description
-     * gets updated, e.g: call hold, however we should restart SRTP only
-     * when the SRTP policy settings are updated.
-     */
-    if (srtp_crypto_cmp(&srtp->tx_policy_neg, &srtp->tx_policy) ||
-	srtp_crypto_cmp(&srtp->rx_policy_neg, &srtp->rx_policy))
-    {
-	status = pjmedia_transport_srtp_start(tp,
-					      &srtp->tx_policy_neg,
-					      &srtp->rx_policy_neg);
-	if (status != PJ_SUCCESS)
-	    return status;
-    }
-
-    srtp->bypass_srtp = PJ_FALSE;
-
-    goto PROPAGATE_MEDIA_START;
-
-BYPASS_SRTP:
-    srtp->bypass_srtp = PJ_TRUE;
-    srtp->peer_use = PJMEDIA_SRTP_DISABLED;
-    if (srtp->session_inited) {
-	pjmedia_transport_srtp_stop(tp);
-    }
-
-PROPAGATE_MEDIA_START:
-    return pjmedia_transport_media_start(srtp->member_tp, pool,
-					 sdp_local, sdp_remote,
-				         media_index);
-}
+    if (srtp->keying_pending_cnt)
+	return PJ_SUCCESS;
+
+    /* Start SRTP */
+    status = start_srtp(srtp);
+
+    return status;
+}
+
 
 static pj_status_t transport_media_stop(pjmedia_transport *tp)
@@ -1830,7 +1483,14 @@
     struct transport_srtp *srtp = (struct transport_srtp*) tp;
     pj_status_t status;
+    unsigned i;
 
     PJ_ASSERT_RETURN(tp, PJ_EINVAL);
 
+    /* Invoke media_stop() of all keying methods */
+    for (i=0; i < srtp->keying_cnt; ++i) {
+	pjmedia_transport_media_stop(srtp->keying[i]);
+    }
+
+    /* Invoke media_stop() of member tp */
     status = pjmedia_transport_media_stop(srtp->member_tp);
     if (status != PJ_SUCCESS)
@@ -1838,6 +1498,8 @@
 		   "SRTP failed stop underlying media transport."));
 
+    /* Finally, stop SRTP */
     return pjmedia_transport_srtp_stop(tp);
 }
+
 
 /* Utility */
